#include <stdlib.h>

#include <stdio.h>
#include <string.h>
#include "time.h"

Time* createTime()
{
	return (Time*)malloc(sizeof(Time));
}

Boolean isNullTime(char buffer[10])
{
	return strcmp(buffer, "--.--") == 0;
}

Time* readTimeFromString(char buffer[10])
{
	Time *time = NULL;
	if (!isNullTime(buffer))
	{
		int hour, min;
		if (sscanf(buffer, "%d.%d", &hour, &min) == 2)
		{
			time = createTime();
			time->hour = hour;
			time->minute = min;
		}
	}
	return time;
}

Boolean validateDayTime(Time t)
{
	return t.hour < 24 && t.hour >= 0 && t.minute < 60 && t.minute >=0;
}

Time difference(Time t1, Time t2)
{
	Time result;
	result.minute = t1.minute - t2.minute;
	result.hour = t1.hour - t2.hour;
	if (result.minute < 0)
	{
		result.hour--;
		result.minute += 60;
	}
	return result;
}

void timeToString(Time *t, char buffer[])
{
	if (t != NULL)
	{
		//Attenzione: considerata corretta anche la stringa di formato "%d.%d"
		sprintf(buffer, "%02d.%02d", t->hour, t->minute);
	}
	else
	{
		strcpy(buffer, "--.--");
	}
}

char* timeToPtrString(Time *t)
{
	char *buffer = (char*)malloc(6 * sizeof(char));	//Andrebbe deallocata!!!

	if (t != NULL)
	{
		sprintf(buffer, "%02d.%02d", t->hour, t->minute);
	}
	else
	{
		strcpy(buffer, "--.--");
	}
	return buffer;
}