#include <string.h>
#include <stdio.h>
#include "trainstop.h"
#include "readField.h"

Boolean inStation(TrainStop stop, StationName name)
{
	return strcmp(stop.station, name) == 0;
}

Boolean readTrainStopFromTxt(FILE *f, TrainStop *stop)
{
	Boolean ok;
	char buffer[30];
	char readSep;

	readSep = readField(stop->station, ';', f);
	if (strcmp(stop->station, "END") == 0)	//Non servirebbe: in caso di terminazione della linea, il separatore  '\n' e non ';' 
		return false;
	ok = readSep == ';';
	if (!ok)
		return false;

	readSep = readField(buffer, '/', f);
	ok = readSep == '/';
	if (!ok)
		return false;
	stop->arrival = readTimeFromString(buffer);

	readSep = readField(buffer, ';', f);
	ok = readSep == ';';
	if (!ok)
		return false;
	stop->departure = readTimeFromString(buffer);
	if (stop->arrival == NULL && stop->departure == NULL)
		return false;

	return true;
}

void trainStopToString(TrainStop stop, char buffer[])
{
	char arrivalTime[20], departureTime[20];
	//char *arrivalTimePtr, departureTimePtr;
	timeToString(stop.arrival, arrivalTime);
	//arrivalTimePtr = timeToStringPtr(stop.arrival);
	timeToString(stop.departure, departureTime);
	//departureTimePtr = timeToStringPtr(stop.departure);

	sprintf(buffer, "%s (%s/%s)", stop.station, arrivalTime, departureTime);
	//sprintf(buffer, "%s (%s/%s)", stop.station, arrivalTimePtr, departureTimePtr);
}